﻿using System.Collections.Immutable;
using Connected.Annotations;
using Connected.ServiceModel;

namespace Connected.Security.Identity;

[Service]
[ServiceUrl(SecurityRoutes.Roles)]
public interface IRoleService
{
	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IRole>?> Query();

	[ServiceMethod(ServiceMethodVerbs.Get)]
	Task<ImmutableList<IRole>?> Query(PrimaryKeyListArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IRole?> Select(PrimaryKeyArgs<int> args);

	[ServiceMethod(ServiceMethodVerbs.Get | ServiceMethodVerbs.Post)]
	Task<IRole?> Select(NameArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post)]
	Task<int> Insert(RoleArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Patch)]
	Task Update(RoleUpdateArgs args);

	[ServiceMethod(ServiceMethodVerbs.Post | ServiceMethodVerbs.Delete)]
	Task Delete(PrimaryKeyArgs<int> args);
}
